#!/bin/sh

/bin/echo "####################################################";
/bin/echo "Welecom to user leelen update software!";
/bin/echo "Version number: V1.3_20200313";
/bin/echo "Applicative equipment: A20";
/bin/echo "###################################################";

success()
{
	/bin/echo "###########################################";
	/bin/echo "successfully update";
	/bin/echo "###########################################";
}

#替换确定名称文件时使用
update_1()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			mv  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			mv $2new_$1 $2$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			mv  /tmp/$1   $2;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}

#替换不确定后缀名文件时使用
update_2()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			cd /tmp/;
			name=$(ls $1);
			echo "begin update $name";
      			cp  /tmp/$name   $2new_$name;
			echo "$2$name" > /mnt/New.txt;
			rm -r $2$1;
			cp $2new_$name $2$name;
			rm -r $2new_$name;
			rm -r /tmp/$name;
			echo "" > /mnt/New.txt;
       		echo "update $name successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
      			rm  /tmp/$1;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}

#复制多份时使用
update_3()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			cp  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			mv $2new_$1 $2$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}


update_4()
{
	if [ -e /tmp/$1 ]; then
		if [ -e $2$1 ]; then
			echo "begin update $1";
      			cp  /tmp/$1   $2new_$1;
			echo "$2$1" > /mnt/New.txt;
			rm -r $2$1;
			cp $2new_$1 $2$1;
			rm -r $2new_$1;
			rm -r /tmp/$1;
			echo "" > /mnt/New.txt;
       		echo "update $1 successfully";
		else
			echo "$2$1 not found";
			echo "begin update $1";
      			cp  /tmp/$1   $2;
      			rm -r /tmp/$1;
			echo "update $1 successfully";
       	fi			
	else
		echo "$1 not found";
	fi
	sync;
}


rename()
{
	if [ -e /tmp/$1* ]; then
		mv  /tmp/$1* /tmp/$1;
	else
		echo " /tmp/$1* not found";
	fi
}

kill_process()
{
  PROCESS_ID=$(ps -ef | grep $1 | grep -v grep | awk '{print $1}')
  echo "kill process:"$1
  echo $PROCESS_ID
  kill -9 $PROCESS_ID
}

killall -USR1 upload.cgi;

kill_process start.sh
kill_process main_EHLX-IS-TS10

#Play upgrading picture
/bin/echo "Play upgrading picture";
/tmp/fbv /tmp/1.jpg &
echo '1'>/sys/class/disp/disp/attr/lcd
echo '255'>/sys/class/disp/disp/attr/lcd_bl

#Establish New.txt
echo "Establish New.txt";
if [ -e /mnt/New.txt ]; then
	echo "" > /mnt/New.txt;
else
	touch /mnt/New.txt;
fi


#kill other 
kill_process boa
kill_process wpa_supplicant

#burn Kernel
if [ -e /tmp/Kernel*.img ]; then
	echo "begin update Kernel";
	cd /tmp/;
	name=$(/bin/ls Kernel*.img);
	/bin/dd if=/tmp/$name of=/dev/nandb;
	/bin/echo "update Kernel successful";      
else
	echo "Kernel not found";
fi

#burn bootloader
if [ -e /tmp/bootloader*.fex ]; then
	echo "begin update bootloader";
	cd /tmp/;
	name=$(/bin/ls bootloader*.fex);
	/bin/umount /dev/nanda;
	/bin/dd if=/tmp/$name of=/dev/nanda;
	/bin/echo "burn bootloader successful";      
else
	echo "bootloader not found";
fi


#update_3 "save.cgi"                          "/mnt/disk/boa/cgi-bin/";

update_3 "linphonerc"                          "/mnt/disk/";
update_3 "linphonerc"                          "/mnt/"

update_3 "config"                          "/mnt/"
update_3 "mon_list"							"/mnt/disk/configbackup/"

update_3 "resolv.conf"                          "/etc/";

update_3 "autorun.sh"					"/"	
update_3 "telnetd"						"/bin/"	
update_3 "tcpdump"						"/bin/"	
update_3 "e2fsck_force"						"/bin/"	


update_3 "libQt5Network.so.5"           "/mnt/disk/lib/"

update_3 "WebUpdateServer"              "/mnt/disk/";

update_2 "main_EHLX-IS-TS10-*"             "/mnt/disk/";


cp -frp /tmp/boa /mnt/disk/
cp -frp /tmp/LLLog /mnt/disk/
cp -frp /tmp/GUI_ELEMENTS /mnt/disk/
cp -frp /tmp/ssl /mnt/disk/
cp -frp /tmp/wav /mnt/disk/

config_path="/mnt/disk/config/config"
config_backup_path="/mnt/disk/configbackup/config"
if [ `grep -c mqtt $config_path` -eq 0 ];then  
    echo 'not have'
    echo [mqtt] >> $config_path
    echo intercom.ave.it= >> $config_path
    echo domain=intercom.ave.it >> $config_path	
    echo enable=0 >> $config_path		
    echo restore=1 >> $config_path	
    echo profile_id=5 >> $config_path
    echo [mqtt] >> $config_backup_path
    echo intercom.ave.it= >> $config_backup_path
    echo domain=intercom.ave.it >> $config_backup_path	
    echo enable=0 >> $config_backup_path		
    echo restore=1 >> $config_backup_path	
    echo profile_id=5 >> $config_backup_path		
else  
    echo 'have'
	sed -i "s/intercom.avespa.it=/intercom.ave.it=/g" $config_backup_path
	sed -i "s/domain=intercom.avespa.it/domain=intercom.ave.it/g" $config_backup_path	
fi 

sed -i "s/lang=en/lang=it/g" $config_backup_path	

#Delete New.txt
echo "Delete New.txt";
#rm -r /mnt/New.txt;
#Play complete upgrade picture
#/bin/echo "begin paly 1.JPG"
#/tmp/fv3 /tmp/1.jpg;
/bin/echo "begin rm FV3,FBV,1.JPG"
/bin/rm -r /tmp/fbv;
/bin/rm -r /tmp/1.jpg;
success;
/sbin/reboot;
exit 0;
